tests: Test retry after partial extents
[nbdkit/ericb.git] / tests / test-retry-extents.sh
blobffcef3111f1ff2138ab61bfd10cef85e1defb7de
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright (C) 2018-2019 Red Hat Inc.
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 source ./functions.sh
34 set -e
35 set -x
37 requires nbdsh --base-allocation -c 'quit()'
39 files="retry-extents-count retry-extents-open-count"
40 rm -f $files
41 cleanup_fn rm -f $files
43 touch retry-extents-count retry-extents-open-count
44 start_t=$SECONDS
46 # Create a custom plugin which will test retrying.
47 nbdkit -v -U - \
48 sh - \
49 --filter=retry retry-delay=1 \
50 --run 'nbdsh --base-allocation --uri $uri -c "
51 entries = []
52 def f (metacontext, offset, e, err):
53 global entries
54 assert err.value == 0
55 assert metacontext == nbd.CONTEXT_BASE_ALLOCATION
56 entries = e
57 h.block_status (1024, 0, f)
58 assert entries == [ 512, 0,
59 512, 3]
60 "' <<'EOF'
61 #!/usr/bin/env bash
62 case "$1" in
63 open)
64 # Count how many times the connection is (re-)opened.
65 read i < retry-extents-open-count
66 echo $((i+1)) > retry-extents-open-count
68 extents)
69 # Fail in three different ways then succeed.
70 read i < retry-extents-count
71 ((i++))
72 echo $i > retry-extents-count
73 case $i in
74 1) echo "EIO pread failed" >&2; exit 1;;
75 2) echo "garbage"
76 exit 0;;
77 3) echo "0 512 0"
78 echo "garbage"
79 exit 0;;
80 *) echo "0 512 0"
81 echo "512 512 3"
82 exit 0;;
83 esac
86 can_extents) exit 0 ;;
87 get_size) echo 1024 ;;
88 *) exit 2 ;;
89 esac
90 EOF
92 # In this test we should see 3 failures:
93 # extents FAILS
94 # retry and wait 1 seconds
95 # extents FAILS
96 # retry and wait 2 seconds
97 # extents FAILS
98 # retry and wait 4 seconds
99 # extents succeeds
101 # The minimum time for the test should be 1+2+4 = 7 seconds.
102 end_t=$SECONDS
103 if [ $((end_t - start_t)) -lt 7 ]; then
104 echo "$0: test ran too quickly"
105 exit 1
108 # Check the handle was opened 4 times (first open + one reopen for
109 # each retry).
110 read open_count < retry-extents-open-count
111 if [ $open_count -ne 4 ]; then
112 echo "$0: open-count ($open_count) != 4"
113 exit 1